SystemOrganization addCategory: #Growl!

FLComponent subclass: #FLGrowl
	instanceVariableNames: 'applicationName applicationIconUrl growlUrl displayName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Growl'!

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 15:50'!
applicationIconUrl

	^ applicationIconUrl! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 15:50'!
applicationIconUrl: aString

	applicationIconUrl := aString! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 15:49'!
applicationName

	^ applicationName! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 15:49'!
applicationName: aString

	applicationName := aString! !

!FLGrowl methodsFor: 'initialization' stamp: 'sebastiansastre 8/23/2012 16:22'!
createComponents 

	super createComponents.
	
	self domBehavior: #(custom).
	
! !

!FLGrowl methodsFor: 'DOM behavior' stamp: 'sebastiansastre 8/23/2012 19:55'!
customDomBehaviorAddTo: aScript on: html 
	"Adds to aScript the custom 'added value' of behavior for the 
	DOM Element which is an homologue of the receiver."

	super customDomBehaviorAddTo: aScript on: html.
	
	aScript 
		add: (self assign: (self registerGrowlFunctionOn: html) as: 'registerGrowl' on: html);
		add: (self assign: (self installGrowlFunctionOn: html) as: 'installGrowl' on: html);
		add: (self assign: (self sendGrowlFunctionOn: html) as: 'sendGrowl' on: html);
		add: (self elementCall: 'installGrowl' on: html);
		yourself.

	^ aScript! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 15:50'!
displayName

	^ displayName! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 15:50'!
displayName: aString

	displayName := aString! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 16:13'!
growlUrl

	^ growlUrl! !

!FLGrowl methodsFor: 'accessing' stamp: 'sebastiansastre 8/23/2012 16:13'!
growlUrl: aString

	growlUrl := aString! !

!FLGrowl methodsFor: 'DOM functions' stamp: 'sebastiansastre 8/25/2012 00:05'!
installGrowlFunctionOn: html

	^ JSFunction new
		add: ('{}' asJSObject assignLocalTo: 'config');
		add: ((self onCallbackFunctionOn: html) assignTo: 'config.oncallback' asJSObject);
		add: ('Growl' asJSObject call: 'init' with: 'config' asJSObject);
		"add: ('growlconnectorcontainer' asJSString asPTElement 
				on: 'element:initialized' 
				do: (self elementCall: 'registerGrowl' on: html));"
		"add: (self elementCall: 'registerGrowl' on: html); 
		add: ((self elementCall: 'registerGrowl' on: html) timeout: 5000); "
		yourself! !

!FLGrowl methodsFor: 'DOM reactions' stamp: 'sebastiansastre 8/25/2012 01:19'!
onCallbackFunctionOn: html

	^ JSFunction new arguments: #('notificationID' 'anAction' 'aContext' 'aType' 'aTimeStamp');

		add: ((self elementOn: html) 
				fire: 'growl:callback' 
				with: (Dictionary new 
						at: 'id' put: 'notificationID' asJSObject;
						at: 'action' put: 'anAction' asJSObject;
						at: 'context' put: 'aContext' asJSObject;
						at: 'type' put: 'aType' asJSObject;
						at: 'timestamp' put: 'aTimeStamp' asJSObject;
						yourself));
		yourself
! !

!FLGrowl methodsFor: 'DOM functions' stamp: 'sebastiansastre 8/23/2012 19:58'!
registerGrowlFunctionOn: html

	^ JSFunction new
		add: ('new Growl.Application()' asJSObject assignLocalTo: 'application');
		add: (applicationName asJSString assignTo: 'application.name' asJSObject);
		add: (applicationIconUrl asJSString assignTo: 'application.icon' asJSObject);
		add: ('new Array()' asJSObject assignLocalTo: 'notificationTypes');
		add: ('new Growl.NotificationType()' asJSObject assignLocalTo: 'nt1');
		add: ('NT1' asJSString assignTo: 'nt1.name' asJSObject);
		add: (displayName asJSString assignTo: 'nt1.displayName' asJSObject);
		add: ('true' asJSObject assignTo: 'nt1.enabled' asJSObject);
		add: ('notificationTypes.push(nt1)' asJSObject);
		add: ('Growl.register(application, notificationTypes)' asJSObject);
		yourself
! !

!FLGrowl methodsFor: 'rendering' stamp: 'sebastiansastre 8/23/2012 18:24'!
renderInnerContentOn: html

	html div 
		id: 'growlconnectorcontainer';
		with:[]

	"html div
		id: 'growlconnectorcontainer';
		with:[
			html embed
				id: 'growlconnector';
				attributeAt: 'name' put: 'growlconnector';
				attributeAt: 'src' put: growlUrl;
				width: 1;
				height: 1;
				attributeAt: 'allowscriptaccess' put: 'always';
				attributeAt: 'type' put: 'application/x-shockwave-flash';
				attributeAt: 'flashvars' put: 'scope=Growl';
				yourself]"! !

!FLGrowl methodsFor: 'DOM functions' stamp: 'sebastiansastre 8/25/2012 00:59'!
sendGrowlFunctionOn: html

	^ JSFunction new arguments: #('aContext' 'anIconUrl' 'aTitle' 'aComment');
		add: ('new Growl.Notification()' asJSObject assignLocalTo: 'notification');
		add: ('NT1' asJSString assignTo: 'notification.name' asJSObject);
		add: ('aTitle' asJSObject assignTo: 'notification.title' asJSObject);
		add: ('aComment' asJSObject assignTo: 'notification.text' asJSObject);
		add: ('anIconUrl' asJSObject assignTo: 'notification.icon' asJSObject);
		add: ('normal' asJSString assignTo: 'notification.priority' asJSObject);
		add: ('aContext' asJSObject assignTo: 'notification.callback.context' asJSObject);
		add: ('string' asJSString assignTo: 'notification.callback.type' asJSObject);
		add: (('Growl.notify("',applicationName,'",notification)') asJSObject);
		yourself
! !
